#!/bin/env python

from Bio import SeqIO
from Bio.SeqRecord import SeqRecord
import sys
import string

# arguments
# 1 : fasta file name
# 2 : quality file name

# processing positiv sequences
handle_fasta = open(sys.argv[1])

# create outhandles
out_handle_fasta = open(sys.argv[1]+".clean", "w")

# seqrecord storage arrays
qual_file = []
new_fasta = []
count =0

# processing the fasta file 
for seq_record in SeqIO.parse(handle_fasta, "fasta") :
	print seq_record.id+"\t"+str(len(seq_record)),
	coords = []
	inc = 0
	start = 1 
	indic = 0
	# searching the non XXed blocks
	for char in seq_record.seq.tostring():
		inc=inc+1
		if char.upper() == 'X':
			if indic != 1 :
				#print "start = "+str(inc)
				if inc !=1:
					coords.append([start,inc])
				indic = 1			
		else :
			if indic != 0 :
				#print "stop = "+str(inc) 
				start = inc
				indic = 0	
	if indic == 0:
		coords.append([start,inc])
	#stop.append(inc)
	print "\n"	
	print coords
	maxi = 0
	inc = 0
	select = -1
	# searching the longest non XXed blocks
	for i in coords:
#		if (i[1] - i[0]) > maxi :
#			select = inc
#                        maxi = (i[1] - i[0])
#		inc = inc+1
#	print str(select)
#	if select > -1:
#		print coords[select]
#		seq_req = SeqRecord(seq_record.seq[int(coords[select][0])-1:int(coords[select][1])-1],seq_record.id,seq_record.description)
		seq_req = SeqRecord(seq_record.seq[i[0]-1:i[1]-1],seq_record.id+"_"+str(i[0])+"_"+str(i[1]),seq_record.description)
		#print seq_req
		new_fasta.append(seq_req)
	else :
		print " is completely Xed"
	count = count+1

SeqIO.write(new_fasta, out_handle_fasta, "fasta")
out_handle_fasta.close()



